#include <stdio.h>
#include <unistd.h>
#include <sys/time.h>

#define TIMEOUT_SEC 10
#define TIMEOUT_USEC 0

int main(int argc, char *argv[])
{
    int pipefd1[2], pipefd2[2];
    char buf[BUFSIZ];
    pid_t pid1, pid2;
    ssize_t len;
    int numfd;              /* $B%G%#%9%/%j%W%??t(B */
    fd_set initfds, rfds;   /* $B%G%#%9%/%j%W%?=89g(B */
    struct timeval timeout; /* $B%?%$%`%"%&%H;~4V(B */
    int ret;

   memset(buf, NULL, sizeof(buf));
    /* $B%G%#%9%/%j%W%?=89g$r=i4|2=$9$k(B */
    FD_ZERO(&initfds);
    /* $B%?%$%`%"%&%HCM$r@_Dj$9$k(B */
    timeout.tv_sec = TIMEOUT_SEC;
    timeout.tv_usec = TIMEOUT_USEC;

    /* $B%Q%$%W(B 1 $B$r@8@.$9$k(B */
    if (pipe(pipefd1) == -1) {
        perror("Can't open pipe");
        exit(1);
    }
    /* $B%Q%$%W(B 2 $B$r@8@.$9$k(B */
    if (pipe(pipefd2) == -1) {
        perror("Can't open pipe");
        exit(1);
    }

    /* $B%G%#%9%/%j%W%?$N:GBgCM$r<hF@$9$k(B */
    numfd = pipefd2[1];

    /* $B%G%#%9%/%j%W%?=89g$K@_Dj$9$k(B */
    FD_SET(pipefd1[0], &initfds);
    FD_SET(pipefd2[0], &initfds);

    /* $B;R%W%m%;%9(B 1 $B$r@8@.$9$k(B */
    if ((pid1 = fork()) == (pid_t)-1) {
        perror("Can't fork");
        exit(1);
    } else if (pid1 == 0) {
        /* $B;R%W%m%;%9(B 1 */
        close(pipefd1[0]);
        while (1) {
            write(pipefd1[1], "Hello\n", 6);
            sleep(5);
        }
        exit(0);
    }

    /* $B;R%W%m%;%9(B 2 $B$r@8@.$9$k(B */
    if ((pid2 = fork()) == (pid_t)-1) {
        perror("Can't fork");
        exit(1);
    } else if (pid2 == 0) {
        /* $B;R%W%m%;%9(B 2 */
        close(pipefd2[0]);
        while (1) {
            write(pipefd2[1], "World\n", 6);
            sleep(2);
        }
        exit(0);
    }

    close(pipefd1[1]);
    close(pipefd2[1]);

    while (1) {
        /* $B%U%!%$%k%G%#%9%/%j%W%?=89g$r=i4|CM$KLa$9(B */
        rfds = initfds;
        ret = select(numfd + 1, &rfds, (fd_set *)0, (fd_set *)0, &timeout);
        if (ret == -1) {
            perror("select");
            exit(1);
        } else if (ret == 0) {
            fprintf(stderr, "Time Out\n");
            exit(1);
        }

        if (FD_ISSET(pipefd1[0], &rfds)) {
            len = read(pipefd1[0], buf, 6);
            write(STDOUT_FILENO, buf, len);
            memset(buf, NULL, sizeof(buf));
        }
        if (FD_ISSET(pipefd2[0], &rfds)) {
            len = read(pipefd2[0], buf, 6);
            write(STDOUT_FILENO, buf, len);
            memset(buf, NULL, sizeof(buf));
        }
    }

    exit(0);
}

