#include <stdio.h>
#include <strings.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netdb.h>
#include <netinet/in.h>
#include <inttypes.h>
#include <sys/types.h>
#include <unistd.h>
#include <string.h>
#include <ctype.h>

#define PORT 1234
#define BACKLOG 5

/* function of send message to client */
void send_msg(int sockfd)
{
    char buf[BUFSIZ];
    char welcome[] = "Welcome!!\n"; /* welcome message */
    int n;
    int i;

    memset(buf, NULL, BUFSIZ);
    /* first send message to client */
    write(sockfd, welcome, sizeof(welcome));

    /* first receive message from client */
    n = read(sockfd, buf, BUFSIZ);

    /* end string "." */
    while (strcmp(buf, ".\r\n") != 0) {
        /* buf string toupper*/
        for (i = 0; i < n; i++) {
            if (isalpha((int)buf[i]))
                buf[i] = toupper(buf[i]);
        }
        /* send message to server */
        write(sockfd, buf, n);

        memset(buf, NULL, BUFSIZ);
        /* receive message from client */
        n = read(sockfd, buf, BUFSIZ);

    }
}

int main(int argc, char *argv[])
{
    int sock, csock;
    struct sockaddr_in servaddr;
    struct sockaddr_in clientaddr;
    socklen_t len;
    pid_t pid;

    /* open socket */
    if ((sock = socket(AF_INET, SOCK_STREAM, 0)) == 0) {
        perror("socket");
        exit(1);
    }
    /* set value of struct sockaddr */
    bzero((char *)&servaddr, sizeof(struct sockaddr_in));
    servaddr.sin_family = AF_INET;
    servaddr.sin_addr.s_addr = htonl(INADDR_ANY);
    servaddr.sin_port = htons(PORT);

    /* bind socket */
    if (bind(sock, (struct sockaddr *)&servaddr,
            sizeof(servaddr)) == -1) {
        perror("bind");
        exit(0);
    }

    /* listen socket */
    if (listen(sock, BACKLOG) < 0) {
        perror("listen");
        exit(1);
    }

    len = sizeof(clientaddr);
    for (;;) {
        /* set accept */
        if ((csock = accept(sock, (struct sockaddr *)&clientaddr,
                        &len)) == -1) {
            perror("accept");
            exit(1);
        }

        if ((pid = fork()) == 0) {
            /* child process */
            close(sock);
            send_msg(csock);
            exit(0);
        }
        close(csock);
    }

    exit(0);
}
